unit Camera;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, QDialogs, Graphics;

type
  TCamera = class(TComponent)
  private
    FFilename : string;
    Picture : TPicture;
    form : TForm;
    hWindow : THandle;
    Camera_index : integer;
    FPreviewrate : integer;
  protected

  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy(); override;
    procedure DestroyCaptureWindow();
    procedure SetFilename(ifilename : string); overload;
    function GetFilename() : string;
    function GetPicture() : TPicture;
    procedure CreateCaptureWindow();//form: TForm);
    procedure SET_SCALE();
    procedure SET_PREVIEWRATE(iPreviewrate : integer);
    procedure SET_PREVIEW();
    function DRIVER_CONNECT(iCamera_index :integer) : integer;
    procedure DRIVER_DISCONNECT();
    procedure DLG_VIDEOFORMAT();
    procedure DLG_VIDEOSOURCE();
    procedure DLG_VIDEOCOMPRESSION();
    procedure GRAB_FRAME();
    procedure EDIT_COPY;
  published
    property Filename : string read FFilename write FFilename;
    property Previewrate : integer read FPreviewRate write FPreviewRate;
  end;

procedure Register;

implementation

const
    WM_CAP_START                    = WM_USER;
    WM_CAP_UNICODE_START            = WM_USER + 100;

    WM_CAP_GET_CAP_STREAMPTR        = WM_CAP_START + 1;

    WM_CAP_SET_CALLBACK_ERRORW      = WM_CAP_UNICODE_START + 2;
    WM_CAP_SET_CALLBACK_STATUSW     = WM_CAP_UNICODE_START + 3;
    WM_CAP_SET_CALLBACK_ERRORA      = WM_CAP_START + 2;
    WM_CAP_SET_CALLBACK_STATUSA     = WM_CAP_START + 3;
    WM_CAP_SET_CALLBACK_ERROR       = WM_CAP_SET_CALLBACK_ERRORA;
    WM_CAP_SET_CALLBACK_STATUS      = WM_CAP_SET_CALLBACK_STATUSA;

    WM_CAP_SET_CALLBACK_YIELD       = WM_CAP_START + 4;
    WM_CAP_SET_CALLBACK_FRAME       = WM_CAP_START + 5;
    WM_CAP_SET_CALLBACK_VIDEOSTREAM = WM_CAP_START + 6;
    WM_CAP_SET_CALLBACK_WAVESTREAM  = WM_CAP_START + 7;
    WM_CAP_GET_USER_DATA            = WM_CAP_START + 8;
    WM_CAP_SET_USER_DATA            = WM_CAP_START + 9;

    WM_CAP_DRIVER_CONNECT           = WM_CAP_START + 10;
    WM_CAP_DRIVER_DISCONNECT        = WM_CAP_START + 11;

    WM_CAP_DRIVER_GET_NAMEA         = WM_CAP_START + 12;
    WM_CAP_DRIVER_GET_VERSIONA      = WM_CAP_START + 13;
    WM_CAP_DRIVER_GET_NAMEW         = WM_CAP_UNICODE_START + 12;
    WM_CAP_DRIVER_GET_VERSIONW      = WM_CAP_UNICODE_START + 13;
    WM_CAP_DRIVER_GET_NAME          = WM_CAP_DRIVER_GET_NAMEA;
    WM_CAP_DRIVER_GET_VERSION       = WM_CAP_DRIVER_GET_VERSIONA;

    WM_CAP_DRIVER_GET_CAPS          = WM_CAP_START + 14;

    WM_CAP_FILE_SET_CAPTURE_FILEA   = WM_CAP_START + 20;
    WM_CAP_FILE_GET_CAPTURE_FILEA   = WM_CAP_START + 21;
    WM_CAP_FILE_SAVEASA             = WM_CAP_START + 23;
    WM_CAP_FILE_SAVEDIBA            = WM_CAP_START + 25;
    WM_CAP_FILE_SET_CAPTURE_FILEW   = WM_CAP_UNICODE_START + 20;
    WM_CAP_FILE_GET_CAPTURE_FILEW   = WM_CAP_UNICODE_START + 21;
    WM_CAP_FILE_SAVEASW             = WM_CAP_UNICODE_START + 23;
    WM_CAP_FILE_SAVEDIBW            = WM_CAP_UNICODE_START + 25;
    WM_CAP_FILE_SET_CAPTURE_FILE    = WM_CAP_FILE_SET_CAPTURE_FILEA;
    WM_CAP_FILE_GET_CAPTURE_FILE    = WM_CAP_FILE_GET_CAPTURE_FILEA;
    WM_CAP_FILE_SAVEAS              = WM_CAP_FILE_SAVEASA;
    WM_CAP_FILE_SAVEDIB             = WM_CAP_FILE_SAVEDIBA;
    WM_CAP_FILE_ALLOCATE            = WM_CAP_START + 22;
    WM_CAP_FILE_SET_INFOCHUNK       = WM_CAP_START + 24;

    WM_CAP_EDIT_COPY                = WM_CAP_START + 30;

    WM_CAP_SET_AUDIOFORMAT          = WM_CAP_START + 35;
    WM_CAP_GET_AUDIOFORMAT          = WM_CAP_START + 36;

    WM_CAP_DLG_VIDEOFORMAT          = WM_CAP_START + 41;
    WM_CAP_DLG_VIDEOSOURCE          = WM_CAP_START + 42;
    WM_CAP_DLG_VIDEODISPLAY         = WM_CAP_START + 43;
    WM_CAP_GET_VIDEOFORMAT          = WM_CAP_START + 44;
    WM_CAP_SET_VIDEOFORMAT          = WM_CAP_START + 45;
    WM_CAP_DLG_VIDEOCOMPRESSION     = WM_CAP_START + 46;

    WM_CAP_SET_PREVIEW              = WM_CAP_START + 50;
    WM_CAP_SET_OVERLAY              = WM_CAP_START + 51;
    WM_CAP_SET_PREVIEWRATE          = WM_CAP_START + 52;
    WM_CAP_SET_SCALE                = WM_CAP_START + 53;
    WM_CAP_GET_STATUS               = WM_CAP_START + 54;
    WM_CAP_SET_SCROLL               = WM_CAP_START + 55;

    WM_CAP_GRAB_FRAME               = WM_CAP_START + 60;
    WM_CAP_GRAB_FRAME_NOSTOP        = WM_CAP_START + 61;

    WM_CAP_SEQUENCE                 = WM_CAP_START + 62;
    WM_CAP_SEQUENCE_NOFILE          = WM_CAP_START + 63;
    WM_CAP_SET_SEQUENCE_SETUP       = WM_CAP_START + 64;
    WM_CAP_GET_SEQUENCE_SETUP       = WM_CAP_START + 65;

    WM_CAP_SET_MCI_DEVICEA          = WM_CAP_START + 66;
    WM_CAP_GET_MCI_DEVICEA          = WM_CAP_START + 67;
    WM_CAP_SET_MCI_DEVICEW          = WM_CAP_UNICODE_START + 66;
    WM_CAP_GET_MCI_DEVICEW          = WM_CAP_UNICODE_START + 67;
    WM_CAP_SET_MCI_DEVICE           = WM_CAP_SET_MCI_DEVICEA;
    WM_CAP_GET_MCI_DEVICE           = WM_CAP_GET_MCI_DEVICEA;

    WM_CAP_STOP                     = WM_CAP_START + 68;
    WM_CAP_ABORT                    = WM_CAP_START + 69;

    WM_CAP_SINGLE_FRAME_OPEN        = WM_CAP_START + 70;
    WM_CAP_SINGLE_FRAME_CLOSE       = WM_CAP_START + 71;
    WM_CAP_SINGLE_FRAME             = WM_CAP_START + 72;

    WM_CAP_PAL_OPENA                = WM_CAP_START + 80;
    WM_CAP_PAL_SAVEA                = WM_CAP_START + 81;
    WM_CAP_PAL_OPENW                = WM_CAP_UNICODE_START + 80;
    WM_CAP_PAL_SAVEW                = WM_CAP_UNICODE_START + 81;
    WM_CAP_PAL_OPEN                 = WM_CAP_PAL_OPENA;
    WM_CAP_PAL_SAVE                 = WM_CAP_PAL_SAVEA;

    WM_CAP_PAL_PASTE                = WM_CAP_START + 82;
    WM_CAP_PAL_AUTOCREATE           = WM_CAP_START + 83;
    WM_CAP_PAL_MANUALCREATE         = WM_CAP_START + 84;

    // Following added post VFW 1.1

    WM_CAP_SET_CALLBACK_CAPCONTROL  = WM_CAP_START + 85;

function capCreateCaptureWindowA(lpszWindowName : PCHAR;
                                dwStyle : longint;
                                x : integer;
                                y : integer;
                                nWidth : integer;
                                nHeight : integer;
                                ParentWin : HWND;
                                nId : integer) : HWND;
                                STDCALL EXTERNAL 'AVICAP32.DLL';

procedure Register;
begin
  RegisterComponents('Gestapo', [TCamera]);
end;

{ TCamera }

constructor TCamera.Create(AOwner: TComponent);
begin
  inherited;
  Picture := TPicture.Create();
  SetFilename('.\capture.bmp');
  Camera_index  := 0;
  Previewrate := 50;
end;

destructor TCamera.Destroy;
begin
  Picture.Free;
  DRIVER_DISCONNECT();
  DestroyCaptureWindow();
  inherited;
end;

procedure TCamera.CreateCaptureWindow();//form: TForm);
begin
  form := TForm.Create(self);
  hWindow := capCreateCaptureWindowA('Camera',
                                {WS_CHILD or} WS_VISIBLE,
                                0, 0, 320, 270,
                                form.Handle,
                                0);
end;

procedure TCamera.DestroyCaptureWindow();
begin
  DestroyWindow(hWindow);
end;

procedure TCamera.SET_SCALE();
begin
  SendMessage(hWindow, WM_CAP_SET_SCALE, 1, 0);
end;

procedure TCamera.DLG_VIDEOFORMAT();
begin
  SendMessage(hWindow, WM_CAP_DLG_VIDEOFORMAT, 0, 0);
end;

procedure TCamera.DLG_VIDEOSOURCE();
begin
  SendMessage(hWindow, WM_CAP_DLG_VIDEOSOURCE, 0, 0);
end;

procedure TCamera.DLG_VIDEOCOMPRESSION();
begin
  SendMessage(hWindow, WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0);
end;

procedure TCamera.GRAB_FRAME();
var Filename2 : LPSTR;
begin
  Filename2 := '.\capture.avi';
  //SendMessage(hWindow, WM_CAP_SET_VIDEOFORMAT, 1000, BITMAPINFO() );
  SendMessage(hWindow, WM_CAP_FILE_SET_CAPTURE_FILE, 0, LPARAM(LPSTR(Filename2)) );
  SendMessage(hWindow, WM_CAP_FILE_SAVEDIB, 0, LPARAM(LPSTR(Filename)) );
  SendMessage(hWindow, WM_CAP_SINGLE_FRAME_OPEN, 0, 0);
  SendMessage(hWindow, WM_CAP_GRAB_FRAME, 0, 0);
  SendMessage(hWindow, WM_CAP_SINGLE_FRAME_CLOSE, 0, 0);
end;

procedure TCamera.EDIT_COPY();
begin
  SendMessage(hWindow, WM_CAP_EDIT_COPY, 0, 0);
end;

function TCamera.GetPicture() : TPicture;
begin
  Picture.LoadFromFile(Filename);
  Result := Picture;
end;

procedure TCamera.SetFilename(ifilename : string);
begin
  Filename := ifilename;
end;

function TCamera.GetFilename() : string;
begin
  Result := Filename;
end;

function TCamera.DRIVER_CONNECT(iCamera_index : integer) : integer;
begin
  Camera_index := iCamera_index;
  Result := SendMessage(hWindow, WM_CAP_DRIVER_CONNECT, Camera_index, 0);
end;

procedure TCamera.DRIVER_DISCONNECT;
begin
  SendMessage(hWindow, WM_CAP_DRIVER_DISCONNECT, Camera_index, 0);
end;

procedure TCamera.SET_PREVIEW;
begin
  SendMessage(hWindow, WM_CAP_SET_PREVIEW, 1, 0);
end;

procedure TCamera.SET_PREVIEWRATE(iPreviewrate: integer);
begin
  Previewrate := iPreviewrate;
  SendMessage(hWindow, WM_CAP_SET_PREVIEWRATE, Previewrate, 0);
end;

end.
