unit Cameras;

interface

uses
  Windows, Messages, SysUtils, Classes, Camera, Forms, Graphics;

type
  TCameras = class(TComponent)
  private
    Fselected_camera : integer;
    camera_count : integer;
    camera_array : Array[0..8] of TCamera;
  protected

  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy(); override;
    function SearchCameras() : integer;
    function getCamera(index : integer) : TCamera;
    function getCameraCount() : integer;
    //function SelectCamera(index : integer) : bool;
    procedure SelectCamera(index : integer);
    procedure SetFilename(ifilename : string);
    function GetFilename() : string;
    function GetPicture() : TPicture;
    procedure DLG_VIDEOFORMAT();
    procedure DLG_VIDEOSOURCE();
    procedure DLG_VIDEOCOMPRESSION();
    procedure GRAB_FRAME();
    procedure EDIT_COPY;
  published
    property selected_camera : integer read Fselected_camera write SelectCamera;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Gestapo', [TCameras]);
end;

{ TCameras }


constructor TCameras.Create(AOwner: TComponent);
begin
  inherited;
  //
end;

destructor TCameras.Destroy;
var i : integer;
begin
  for i:=0 to camera_count-1 do
    camera_array[i].Free;
  inherited;
end;

procedure TCameras.DLG_VIDEOCOMPRESSION;
begin
  (camera_array[selected_camera]).DLG_VIDEOCOMPRESSION();
end;

procedure TCameras.DLG_VIDEOFORMAT;
begin
  (camera_array[selected_camera]).DLG_VIDEOFORMAT();
end;

procedure TCameras.DLG_VIDEOSOURCE;
begin
  (camera_array[selected_camera]).DLG_VIDEOSOURCE();
end;

procedure TCameras.EDIT_COPY;
begin
  (camera_array[selected_camera]).EDIT_COPY();
end;

function TCameras.getCamera(index: integer): TCamera;
begin
  if  (index < 0) or (index >= camera_count) then Result := nil
  else Result := camera_array[index];
end;

function TCameras.getCameraCount: integer;
begin
  Result := camera_count;
end;

function TCameras.GetFilename: string;
begin
  Result := (camera_array[selected_camera]).GetFilename();
end;

function TCameras.GetPicture: TPicture;
begin
  Result := (camera_array[selected_camera]).GetPicture();
end;

procedure TCameras.GRAB_FRAME;
begin
  (camera_array[selected_camera]).GRAB_FRAME();
end;

function TCameras.SearchCameras(): integer;
var i,camera_found : integer; camera : TCamera; //form : TForm;
begin
  i:=0;
  //form := TForm.Create(self);
  //camera_found := 0;
  //repeat
  while (i < 9) do
  begin
    camera := TCamera.Create(self);//form);
    camera.CreateCaptureWindow();//form);
    camera_found := camera.DRIVER_CONNECT(i);
    if (camera_found = 0) then break;
    camera.SET_SCALE();
    camera.SET_PREVIEWRATE(50);
    camera.SET_PREVIEW();
    camera_array[i] := camera;
    i := i + 1;
  end;
  //until (i < 9);
  camera.DRIVER_DISCONNECT();
  camera.Destroy();
  //form.Destroy;
  camera_count := i;
  Result := camera_count;
end;

{function TCameras.SelectCamera(index: integer): bool;
begin
  if  (index < 0) or (index >= camera_count) then Result := false
  else begin
    selected_camera := index;
    Result := true;
  end;
end;
}
procedure TCameras.SelectCamera(index: integer);
begin
  if  (index < 0) or (index >= camera_count) then exit;
  Fselected_camera := index;
end;

procedure TCameras.SetFilename(ifilename: string);
begin
 (camera_array[selected_camera]).SetFilename(ifilename);
end;

end.
