unit helptools;

interface
uses
  SysUtils,Classes;

function SubStr( a : string; StartPos  : integer; EndPos : integer): string; overload;
function SubStr( a : string; separator : char) : string; overload;
function ParseString(var a : string; breakchar : Char = ' '; invert : integer = 0) : string;
function StringToStringList(line : string; separator : char) : TStringList;
function StringListToString(list : TStringList; separator : char): string;

implementation

function SubStr( a : string; StartPos  : integer; EndPos   : integer): String;
begin
  Result := Copy(a, StartPos, EndPos-StartPos);
end;

function SubStr( a : string; separator : char) : string;
var len : integer;
    i,j : integer;
begin
  len := length(a);
  result := '';
  if len = 0 then
    exit;

  for i:=0 to len-1 do begin
    if a[i] = separator then begin
      for j:=0 to i-1 do
        result := result + a[j];
      exit;
    end;
  end;
end;

function ParseString(var a : string; breakchar : Char = ' '; invert : integer = 0) : string;
var len,i : integer;
var b : string;
var islastchar : integer;
begin
  b := '';
  islastchar := 0;
  len := Length(a);
  if len = 0 then exit;
  i:=0;
  if invert = 0 then begin
    while true do
    begin
      if a[i] = breakchar then
      begin
        if i = len then islastchar := 1;
        break;
      end;
      if i = len then break;
      i:=i+1;
    end;
    if islastchar = 1 then
    begin
      b := SubStr(a,0,len-1);   // take away breakchar
      a := '';                  // no need to do more
    end;
    if (i > 0) and (i < len) then
    begin
      b := SubStr(a,0,i-1);
      a := SubStr(a,i+1,len+1);
    end;
  end;

  if invert = 1 then begin
    for i:=len-1 downto 0 do
      if a[i] = breakchar then break;
    if (i <> 0) and (i <> len) then
    begin
      b := SubStr(a,i+1,len+1); //StrRight(PChar(a),i);
      a := SubStr(a,0,i-1); //StrLeft(PChar(a),i-1);
    end;
  end;
  Result := b;
end;

function StringToStringList(line : string; separator : char): TStringList;
var list : TStringList;
    help : string;
begin
  if line = '' then begin
    result := nil;
    exit;
  end;

  list := TStringList.Create;
  while true do begin
    help := ParseString(line, separator);
    if help = '' then
      break;
    list.Add(help);
  end;
  result := list;
  list.Add(line);
end;

function StringListToString(list : TStringList; separator : char): string;
var help : string;
    i : integer;
begin
  if list = nil then begin
    result := '';
    exit;
  end;

  i := 0;
  while i < list.count -1 do begin
    help := help + list.Strings[i];
    help := help + separator;
    i := i + 1;
  end;
  help := help + list.Strings[i];
  result := help;
end;

end.
